Index: serefpolicy-contrib-20140730/conman.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/conman.if
@@ -0,0 +1,142 @@
+## <summary>Conman is a program for connecting to remote consoles being managed by conmand</summary>
+
+########################################
+## <summary>
+##	Execute conman in the conman domin.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`conman_domtrans',`
+	gen_require(`
+		type conman_t, conman_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, conman_exec_t, conman_t)
+')
+
+########################################
+## <summary>
+##	Read conman's log files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`conman_read_log',`
+	gen_require(`
+		type conman_log_t;
+	')
+
+	logging_search_logs($1)
+	read_files_pattern($1, conman_log_t, conman_log_t)
+')
+
+########################################
+## <summary>
+##	Append to conman log files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`conman_append_log',`
+	gen_require(`
+		type conman_log_t;
+	')
+
+	logging_search_logs($1)
+	append_files_pattern($1, conman_log_t, conman_log_t)
+')
+
+########################################
+## <summary>
+##	Manage conman log files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`conman_manage_log',`
+	gen_require(`
+		type conman_log_t;
+	')
+
+	logging_search_logs($1)
+	manage_dirs_pattern($1, conman_log_t, conman_log_t)
+	manage_files_pattern($1, conman_log_t, conman_log_t)
+')
+
+########################################
+## <summary>
+##	Execute conman server in the conman domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`conman_systemctl',`
+	gen_require(`
+		type conman_t;
+		type conman_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+    systemd_read_fifo_file_passwd_run($1)
+	allow $1 conman_unit_file_t:file read_file_perms;
+	allow $1 conman_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, conman_t)
+')
+
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an conman environment
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`conman_admin',`
+	gen_require(`
+		type conman_t;
+		type conman_log_t;
+	    type conman_unit_file_t;
+	')
+
+	allow $1 conman_t:process { signal_perms };
+	ps_process_pattern($1, conman_t)
+
+    tunable_policy(`deny_ptrace',`',`
+        allow $1 conman_t:process ptrace;
+    ')
+
+	logging_search_logs($1)
+	admin_pattern($1, conman_log_t)
+
+	conman_systemctl($1)
+	admin_pattern($1, conman_unit_file_t)
+	allow $1 conman_unit_file_t:service all_service_perms;
+
+	optional_policy(`
+		systemd_passwd_agent_exec($1)
+		systemd_read_fifo_file_passwd_run($1)
+	')
+')
Index: serefpolicy-contrib-20140730/conman.te
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/conman.te
@@ -0,0 +1,49 @@
+policy_module(conman, 1.0.0)
+
+########################################
+#
+# Declarations
+#
+
+type conman_t;
+type conman_exec_t;
+init_daemon_domain(conman_t, conman_exec_t)
+
+type conman_log_t;
+logging_log_file(conman_log_t)
+
+type conman_unit_file_t;
+systemd_unit_file(conman_unit_file_t)
+
+########################################
+#
+# conman local policy
+#
+
+allow conman_t self:capability { sys_tty_config };
+allow conman_t self:process { setrlimit signal_perms };
+
+allow conman_t self:fifo_file rw_fifo_file_perms;
+allow conman_t self:unix_stream_socket create_stream_socket_perms;
+allow conman_t self:tcp_socket { accept listen create_socket_perms };
+
+manage_dirs_pattern(conman_t, conman_log_t, conman_log_t)
+manage_files_pattern(conman_t, conman_log_t, conman_log_t)
+logging_log_filetrans(conman_t, conman_log_t, { dir })
+
+corenet_tcp_bind_generic_node(conman_t)
+corenet_tcp_bind_conman_port(conman_t)
+
+corecmd_exec_bin(conman_t)
+
+auth_read_passwd(conman_t)
+
+logging_send_syslog_msg(conman_t)
+
+sysnet_dns_name_resolve(conman_t)
+
+userdom_use_user_ptys(conman_t)
+
+optional_policy(`
+    freeipmi_stream_connect(conman_t)
+')
Index: serefpolicy-contrib-20140730/consolekit.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/consolekit.fc
+++ serefpolicy-contrib-20140730/consolekit.fc
@@ -1,3 +1,5 @@
+/usr/lib/systemd/system/console-kit.*  -- gen_context(system_u:object_r:consolekit_unit_file_t,s0)
+
 /usr/sbin/console-kit-daemon	--	gen_context(system_u:object_r:consolekit_exec_t,s0)
 
 /var/log/ConsoleKit(/.*)?	gen_context(system_u:object_r:consolekit_log_t,s0)
Index: serefpolicy-contrib-20140730/consolekit.if
===================================================================
--- serefpolicy-contrib-20140730.orig/consolekit.if
+++ serefpolicy-contrib-20140730/consolekit.if
@@ -21,6 +21,27 @@ interface(`consolekit_domtrans',`
 
 ########################################
 ## <summary>
+##	dontaudit Send and receive messages from
+##	consolekit over dbus.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain to not audit.
+##	</summary>
+## </param>
+#
+interface(`consolekit_dontaudit_dbus_chat',`
+	gen_require(`
+		type consolekit_t;
+		class dbus send_msg;
+	')
+
+	dontaudit $1 consolekit_t:dbus send_msg;
+	dontaudit consolekit_t $1:dbus send_msg;
+')
+
+########################################
+## <summary>
 ##	Send and receive messages from
 ##	consolekit over dbus.
 ## </summary>
@@ -42,6 +63,24 @@ interface(`consolekit_dbus_chat',`
 
 ########################################
 ## <summary>
+##	Dontaudit attempts to read consolekit log files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain to not audit.
+##	</summary>
+## </param>
+#
+interface(`consolekit_dontaudit_read_log',`
+	gen_require(`
+		type consolekit_log_t;
+	')
+
+	dontaudit $1 consolekit_log_t:file read_file_perms;
+')
+
+########################################
+## <summary>
 ##	Read consolekit log files.
 ## </summary>
 ## <param name="domain">
@@ -98,3 +137,64 @@ interface(`consolekit_read_pid_files',`
 	allow $1 consolekit_var_run_t:dir list_dir_perms;
 	read_files_pattern($1, consolekit_var_run_t, consolekit_var_run_t)
 ')
+
+########################################
+## <summary>
+##	List consolekit PID files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`consolekit_list_pid_files',`
+	gen_require(`
+		type consolekit_var_run_t;
+	')
+
+	files_search_pids($1)
+	list_dirs_pattern($1, consolekit_var_run_t, consolekit_var_run_t)
+')
+
+########################################
+## <summary>
+##	Allow the domain to read consolekit state files in /proc.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`consolekit_read_state',`
+	gen_require(`
+		type consolekit_t;
+	')
+
+	kernel_search_proc($1)
+	ps_process_pattern($1, consolekit_t)
+')
+
+########################################
+## <summary>
+##	Execute consolekit server in the consolekit domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`consolekit_systemctl',`
+	gen_require(`
+		type consolekit_t;
+		type consolekit_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 consolekit_unit_file_t:file read_file_perms;
+	allow $1 consolekit_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, consolekit_t)
+')
Index: serefpolicy-contrib-20140730/consolekit.te
===================================================================
--- serefpolicy-contrib-20140730.orig/consolekit.te
+++ serefpolicy-contrib-20140730/consolekit.te
@@ -1,4 +1,4 @@
-policy_module(consolekit, 1.9.1)
+policy_module(consolekit, 1.9.0)
 
 ########################################
 #
@@ -17,7 +17,10 @@ files_tmpfs_file(consolekit_tmpfs_t)
 
 type consolekit_var_run_t;
 files_pid_file(consolekit_var_run_t)
-init_daemon_pid_file(consolekit_var_run_t, dir, "ConsoleKit")
+init_daemon_run_dir(consolekit_var_run_t, "ConsoleKit")
+
+type consolekit_unit_file_t;
+systemd_unit_file(consolekit_unit_file_t)
 
 ########################################
 #
@@ -25,15 +28,14 @@ init_daemon_pid_file(consolekit_var_run_
 #
 
 allow consolekit_t self:capability { chown setuid setgid sys_tty_config dac_override sys_nice sys_ptrace };
+
 allow consolekit_t self:process { getsched signal };
 allow consolekit_t self:fifo_file rw_fifo_file_perms;
 allow consolekit_t self:unix_stream_socket { accept listen };
 
-create_files_pattern(consolekit_t, consolekit_log_t, consolekit_log_t)
-append_files_pattern(consolekit_t, consolekit_log_t, consolekit_log_t)
-read_files_pattern(consolekit_t, consolekit_log_t, consolekit_log_t)
-setattr_files_pattern(consolekit_t, consolekit_log_t, consolekit_log_t)
-logging_log_filetrans(consolekit_t, consolekit_log_t, file)
+manage_dirs_pattern(consolekit_t, consolekit_log_t, consolekit_log_t)
+manage_files_pattern(consolekit_t, consolekit_log_t, consolekit_log_t)
+logging_log_filetrans(consolekit_t, consolekit_log_t, { dir file })
 
 manage_dirs_pattern(consolekit_t, consolekit_var_run_t, consolekit_var_run_t)
 manage_files_pattern(consolekit_t, consolekit_var_run_t, consolekit_var_run_t)
@@ -54,38 +56,37 @@ dev_read_sysfs(consolekit_t)
 
 domain_read_all_domains_state(consolekit_t)
 domain_use_interactive_fds(consolekit_t)
-domain_dontaudit_ptrace_all_domains(consolekit_t)
 
-files_read_usr_files(consolekit_t)
+# needs to read /var/lib/dbus/machine-id
 files_read_var_lib_files(consolekit_t)
 files_search_all_mountpoints(consolekit_t)
 
 fs_list_inotifyfs(consolekit_t)
 
-mcs_ptrace_all(consolekit_t)
-
 term_use_all_terms(consolekit_t)
 
 auth_use_nsswitch(consolekit_t)
 auth_manage_pam_console_data(consolekit_t)
 auth_write_login_records(consolekit_t)
 auth_create_pam_console_data_dirs(consolekit_t)
-auth_pid_filetrans_pam_var_console(consolekit_t, dir, "console")
+
+init_read_utmp(consolekit_t)
 
 logging_send_syslog_msg(consolekit_t)
 logging_send_audit_msgs(consolekit_t)
 
-miscfiles_read_localization(consolekit_t)
+systemd_exec_systemctl(consolekit_t)
+systemd_start_power_services(consolekit_t)
 
+userdom_read_all_users_state(consolekit_t)
 userdom_dontaudit_read_user_home_content_files(consolekit_t)
+userdom_dontaudit_getattr_admin_home_files(consolekit_t)
 userdom_read_user_tmp_files(consolekit_t)
 
-tunable_policy(`use_nfs_home_dirs',`
-	fs_read_nfs_files(consolekit_t)
-')
+userdom_home_reader(consolekit_t)
 
-tunable_policy(`use_samba_home_dirs',`
-	fs_read_cifs_files(consolekit_t)
+optional_policy(`
+	cron_read_system_job_lib_files(consolekit_t)
 ')
 
 optional_policy(`
@@ -109,13 +110,6 @@ optional_policy(`
 	')
 ')
 
-optional_policy(`
-	hal_ptrace(consolekit_t)
-')
-
-optional_policy(`
-	networkmanager_append_log_files(consolekit_t)
-')
 
 optional_policy(`
 	policykit_domtrans_auth(consolekit_t)
Index: serefpolicy-contrib-20140730/corosync.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/corosync.fc
+++ serefpolicy-contrib-20140730/corosync.fc
@@ -1,5 +1,7 @@
 /etc/rc\.d/init\.d/corosync	--	gen_context(system_u:object_r:corosync_initrc_exec_t,s0)
 
+/usr/lib/systemd/system/corosync.*  -- gen_context(system_u:object_r:corosync_unit_file_t,s0)
+
 /usr/sbin/corosync	--	gen_context(system_u:object_r:corosync_exec_t,s0)
 /usr/sbin/corosync-notifyd	--	gen_context(system_u:object_r:corosync_exec_t,s0)
 
Index: serefpolicy-contrib-20140730/corosync.if
===================================================================
--- serefpolicy-contrib-20140730.orig/corosync.if
+++ serefpolicy-contrib-20140730/corosync.if
@@ -77,6 +77,25 @@ interface(`corosync_read_log',`
 	read_files_pattern($1, corosync_var_log_t, corosync_var_log_t)
 ')
 
+#######################################
+## <summary>
+##	Setattr corosync log files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`corosync_setattr_log',`
+	gen_require(`
+		type corosync_var_log_t;
+	')
+
+	setattr_files_pattern($1, corosync_var_log_t, corosync_var_log_t)
+')
+
+
 #####################################
 ## <summary>
 ##	Connect to corosync over a unix
@@ -91,29 +110,54 @@ interface(`corosync_read_log',`
 interface(`corosync_stream_connect',`
 	gen_require(`
 		type corosync_t, corosync_var_run_t;
+		type corosync_var_lib_t;
 	')
 
 	files_search_pids($1)
+	stream_connect_pattern($1, corosync_var_lib_t, corosync_var_lib_t, corosync_t)
 	stream_connect_pattern($1, corosync_var_run_t, corosync_var_run_t, corosync_t)
 ')
 
 ######################################
 ## <summary>
-##	Read and write corosync tmpfs files.
+##  Allow the specified domain to read/write corosync's tmpfs files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`corosync_rw_tmpfs',`
+    gen_require(`
+        type corosync_tmpfs_t;
+    ')
+
+	rw_files_pattern($1, corosync_tmpfs_t, corosync_tmpfs_t)
+
+')
+
+########################################
+## <summary>
+##	Execute corosync server in the corosync domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
 #
-interface(`corosync_rw_tmpfs',`
+interface(`corosync_systemctl',`
 	gen_require(`
-		type corosync_tmpfs_t;
+		type corosync_t;
+		type corosync_unit_file_t;
 	')
 
-	fs_search_tmpfs($1)
-	rw_files_pattern($1, corosync_tmpfs_t, corosync_tmpfs_t)
+	systemd_exec_systemctl($1)
+	allow $1 corosync_unit_file_t:file read_file_perms;
+	allow $1 corosync_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, corosync_t)
 ')
 
 ######################################
@@ -160,12 +204,17 @@ interface(`corosync_admin',`
 		type corosync_t, corosync_var_lib_t, corosync_var_log_t;
 		type corosync_var_run_t, corosync_tmp_t, corosync_tmpfs_t;
 		type corosync_initrc_exec_t;
+		type corosync_unit_file_t;
 	')
 
-	allow $1 corosync_t:process { ptrace signal_perms };
+	allow $1 corosync_t:process signal_perms;
 	ps_process_pattern($1, corosync_t)
 
-	corosync_initrc_domtrans($1)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 corosync_t:process ptrace;
+	')
+
+	init_labeled_script_domtrans($1, corosync_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 corosync_initrc_exec_t system_r;
 	allow $2 system_r;
@@ -183,4 +232,8 @@ interface(`corosync_admin',`
 
 	files_list_pids($1)
 	admin_pattern($1, corosync_var_run_t)
+
+	corosync_systemctl($1)
+	admin_pattern($1, corosync_unit_file_t)
+	allow $1 corosync_unit_file_t:service all_service_perms;
 ')
Index: serefpolicy-contrib-20140730/corosync.te
===================================================================
--- serefpolicy-contrib-20140730.orig/corosync.te
+++ serefpolicy-contrib-20140730/corosync.te
@@ -28,6 +28,9 @@ logging_log_file(corosync_var_log_t)
 type corosync_var_run_t;
 files_pid_file(corosync_var_run_t)
 
+type corosync_unit_file_t;
+systemd_unit_file(corosync_unit_file_t)
+
 ########################################
 #
 # Local policy
@@ -93,7 +96,6 @@ dev_read_urand(corosync_t)
 domain_read_all_domains_state(corosync_t)
 
 files_manage_mounttab(corosync_t)
-files_read_usr_files(corosync_t)
 
 auth_use_nsswitch(corosync_t)
 
@@ -106,7 +108,13 @@ logging_send_syslog_msg(corosync_t)
 miscfiles_read_localization(corosync_t)
 
 userdom_read_user_tmp_files(corosync_t)
-userdom_manage_user_tmpfs_files(corosync_t)
+userdom_delete_user_tmp_files(corosync_t)
+userdom_rw_user_tmp_files(corosync_t)
+
+optional_policy(`
+	fs_manage_tmpfs_files(corosync_t)
+	init_manage_script_status_files(corosync_t)
+')
 
 optional_policy(`
 	ccs_read_config(corosync_t)
@@ -129,20 +137,29 @@ optional_policy(`
 ')
 
 optional_policy(`
+	lvm_rw_clvmd_tmpfs_files(corosync_t)
+	lvm_delete_clvmd_tmpfs_files(corosync_t)
+')
+
+optional_policy(`
 	qpidd_rw_shm(corosync_t)
 ')
 
 optional_policy(`
-	rhcs_getattr_fenced_exec_files(corosync_t)
+	rhcs_getattr_fenced(corosync_t)
+	# to communication with RHCS
 	rhcs_rw_cluster_shm(corosync_t)
 	rhcs_rw_cluster_semaphores(corosync_t)
 	rhcs_stream_connect_cluster(corosync_t)
+	rhcs_read_cluster_lib_files(corosync_t)
+	rhcs_manage_cluster_lib_files(corosync_t)
+	rhcs_relabel_cluster_lib_files(corosync_t)
 ')
 
 optional_policy(`
-	rgmanager_manage_tmpfs_files(corosync_t)
+	rpc_search_nfs_state_data(corosync_t)
 ')
 
 optional_policy(`
-	rpc_search_nfs_state_data(corosync_t)
-')
\ No newline at end of file
+    wdmd_rw_tmpfs(corosync_t)
+')
Index: serefpolicy-contrib-20140730/couchdb.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/couchdb.fc
+++ serefpolicy-contrib-20140730/couchdb.fc
@@ -1,9 +1,14 @@
-/etc/couchdb(/.*)?			gen_context(system_u:object_r:couchdb_conf_t,s0)
+
+/usr/lib/systemd/system/couchdb.*		--	gen_context(system_u:object_r:couchdb_unit_file_t,s0)
+
+/etc/couchdb(/.*)?	gen_context(system_u:object_r:couchdb_conf_t,s0)
+
 /etc/rc\.d/init\.d/couchdb	--	gen_context(system_u:object_r:couchdb_initrc_exec_t,s0)
 
-/usr/bin/couchdb		--	gen_context(system_u:object_r:couchdb_exec_t,s0)
-/usr/lib/couchdb/bin/couchjs	--	gen_context(system_u:object_r:couchdb_js_exec_t,s0)
+/usr/bin/couchdb	--	gen_context(system_u:object_r:couchdb_exec_t,s0)
+
+/var/lib/couchdb(/.*)?	gen_context(system_u:object_r:couchdb_var_lib_t,s0)
+
+/var/log/couchdb(/.*)?	gen_context(system_u:object_r:couchdb_log_t,s0)
 
-/var/lib/couchdb(/.*)?			gen_context(system_u:object_r:couchdb_var_lib_t,s0)
-/var/log/couchdb(/.*)?			gen_context(system_u:object_r:couchdb_log_t,s0)
-/var/run/couchdb(/.*)?			gen_context(system_u:object_r:couchdb_var_run_t,s0)
+/var/run/couchdb(/.*)?	gen_context(system_u:object_r:couchdb_var_run_t,s0)
Index: serefpolicy-contrib-20140730/couchdb.if
===================================================================
--- serefpolicy-contrib-20140730.orig/couchdb.if
+++ serefpolicy-contrib-20140730/couchdb.if
@@ -2,7 +2,7 @@
 
 ########################################
 ## <summary>
-##	Read couchdb log files.
+##	Allow to read couchdb log files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -15,13 +15,13 @@ interface(`couchdb_read_log_files',`
 		type couchdb_log_t;
 	')
 
-	logging_search_logs($1)
+	files_search_var_lib($1)
 	read_files_pattern($1, couchdb_log_t, couchdb_log_t)
 ')
 
 ########################################
 ## <summary>
-##	Read, write, and create couchdb lib files.
+##	Allow to read couchdb lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -29,7 +29,7 @@ interface(`couchdb_read_log_files',`
 ##	</summary>
 ## </param>
 #
-interface(`couchdb_manage_lib_files',`
+interface(`couchdb_read_lib_files',`
 	gen_require(`
 		type couchdb_var_lib_t;
 	')
@@ -40,7 +40,46 @@ interface(`couchdb_manage_lib_files',`
 
 ########################################
 ## <summary>
-##	Read couchdb config files.
+##	All of the rules required to
+##	administrate an couchdb environment.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`couchdb_manage_lib_files',`
+	gen_require(`
+		type couchdb_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_files_pattern($1, couchdb_var_lib_t, couchdb_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage couchdb lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`couchdb_manage_lib_dirs',`
+	gen_require(`
+		type couchdb_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_dirs_pattern($1, couchdb_var_lib_t, couchdb_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Allow to read couchdb conf files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -53,13 +92,13 @@ interface(`couchdb_read_conf_files',`
 		type couchdb_conf_t;
 	')
 
-	files_search_etc($1)
+	files_search_var_lib($1)
 	read_files_pattern($1, couchdb_conf_t, couchdb_conf_t)
 ')
 
 ########################################
 ## <summary>
-##	Read couchdb pid files.
+##	Read couchdb PID files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -73,19 +112,87 @@ interface(`couchdb_read_pid_files',`
 	')
 
 	files_search_pids($1)
-	read_files_pattern($1, couchdb_var_run_t, couchdb_var_run_t)
+	allow $1 couchdb_var_run_t:file read_file_perms;
+')
+
+#######################################
+## <summary>
+##      Search couchdb PID dirs.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`couchdb_search_pid_dirs',`
+        gen_require(`
+                type couchdb_var_run_t;
+        ')
+
+        files_search_pids($1)
+        allow $1 couchdb_var_run_t:dir search_dir_perms;
+')
+
+#######################################
+## <summary>
+##  Allow domain to manage couchdb content.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`couchdb_manage_files',`
+        gen_require(`
+                type couchdb_var_run_t;
+                type couchdb_log_t;
+                type couchdb_var_lib_t;
+                type couchdb_conf_t;
+        ')
+
+    manage_files_pattern($1, couchdb_log_t, couchdb_log_t)
+    manage_files_pattern($1, couchdb_var_lib_t, couchdb_var_lib_t)
+    manage_files_pattern($1, couchdb_var_run_t, couchdb_var_run_t)
+    manage_files_pattern($1, couchdb_conf_t, couchdb_conf_t)
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an couchdb environment.
+##	Execute couchdb server in the couchdb domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
+#
+interface(`couchdb_systemctl',`
+	gen_require(`
+		type couchdb_t;
+		type couchdb_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+	systemd_read_fifo_file_passwd_run($1)
+	allow $1 couchdb_unit_file_t:file read_file_perms;
+	allow $1 couchdb_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, couchdb_t)
+')
+
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an couchdb environment
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+## </summary>
+## </param>
 ## <param name="role">
 ##	<summary>
 ##	Role allowed access.
@@ -95,14 +202,19 @@ interface(`couchdb_read_pid_files',`
 #
 interface(`couchdb_admin',`
 	gen_require(`
+		type couchdb_unit_file_t;
 		type couchdb_t, couchdb_conf_t, couchdb_initrc_exec_t;
 		type couchdb_log_t, couchdb_var_lib_t, couchdb_var_run_t;
 		type couchdb_tmp_t;
 	')
 
-	allow $1 couchdb_t:process { ptrace signal_perms };
+	allow $1 couchdb_t:process { signal_perms };
 	ps_process_pattern($1, couchdb_t)
 
+    tunable_policy(`deny_ptrace',`',`
+        allow $1 couchdb_t:process ptrace;
+    ')
+
 	init_labeled_script_domtrans($1, couchdb_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 couchdb_initrc_exec_t system_r;
@@ -122,4 +234,13 @@ interface(`couchdb_admin',`
 
 	files_search_pids($1)
 	admin_pattern($1, couchdb_var_run_t)
+
+	admin_pattern($1, couchdb_unit_file_t)
+	couchdb_systemctl($1)
+	allow $1 couchdb_unit_file_t:service all_service_perms;
+
+	optional_policy(`
+		systemd_passwd_agent_exec($1)
+		systemd_read_fifo_file_passwd_run($1)
+	')
 ')
Index: serefpolicy-contrib-20140730/couchdb.te
===================================================================
--- serefpolicy-contrib-20140730.orig/couchdb.te
+++ serefpolicy-contrib-20140730/couchdb.te
@@ -1,4 +1,4 @@
-policy_module(couchdb, 1.2.1)
+policy_module(couchdb, 1.1.1)
 
 ########################################
 #
@@ -9,10 +9,6 @@ type couchdb_t;
 type couchdb_exec_t;
 init_daemon_domain(couchdb_t, couchdb_exec_t)
 
-type couchdb_js_t;
-type couchdb_js_exec_t;
-init_daemon_domain(couchdb_js_t, couchdb_js_exec_t)
-
 type couchdb_initrc_exec_t;
 init_script_file(couchdb_initrc_exec_t)
 
@@ -30,14 +26,16 @@ files_type(couchdb_var_lib_t)
 
 type couchdb_var_run_t;
 files_pid_file(couchdb_var_run_t)
-init_daemon_pid_file(couchdb_var_run_t, dir, "couchdb")
+
+type couchdb_unit_file_t;
+systemd_unit_file(couchdb_unit_file_t)
 
 ########################################
 #
-# couchdb policy
+# Local policy
 #
 
-allow couchdb_t self:process { getsched setsched signal signull sigkill };
+allow couchdb_t self:process { setsched signal signull sigkill };
 allow couchdb_t self:fifo_file rw_fifo_file_perms;
 allow couchdb_t self:unix_stream_socket create_stream_socket_perms;
 allow couchdb_t self:tcp_socket { accept listen };
@@ -45,10 +43,6 @@ allow couchdb_t self:tcp_socket { accept
 allow couchdb_t couchdb_conf_t:dir list_dir_perms;
 allow couchdb_t couchdb_conf_t:file read_file_perms;
 
-can_exec(couchdb_t, couchdb_exec_t)
-
-domtrans_pattern(couchdb_t, couchdb_js_exec_t, couchdb_js_t)
-
 manage_dirs_pattern(couchdb_t, couchdb_log_t, couchdb_log_t)
 append_files_pattern(couchdb_t, couchdb_log_t, couchdb_log_t)
 create_files_pattern(couchdb_t, couchdb_log_t, couchdb_log_t)
@@ -67,6 +61,8 @@ manage_dirs_pattern(couchdb_t, couchdb_v
 manage_files_pattern(couchdb_t, couchdb_var_run_t, couchdb_var_run_t)
 files_pid_filetrans(couchdb_t, couchdb_var_run_t, dir)
 
+can_exec(couchdb_t, couchdb_exec_t)
+
 kernel_read_system_state(couchdb_t)
 
 corecmd_exec_bin(couchdb_t)
@@ -77,7 +73,6 @@ corenet_all_recvfrom_netlabel(couchdb_t)
 corenet_tcp_sendrecv_generic_if(couchdb_t)
 corenet_tcp_sendrecv_generic_node(couchdb_t)
 corenet_tcp_bind_generic_node(couchdb_t)
-corenet_udp_bind_generic_node(couchdb_t)
 
 corenet_sendrecv_couchdb_server_packets(couchdb_t)
 corenet_tcp_bind_couchdb_port(couchdb_t)
@@ -87,27 +82,7 @@ dev_list_sysfs(couchdb_t)
 dev_read_sysfs(couchdb_t)
 dev_read_urand(couchdb_t)
 
-files_read_usr_files(couchdb_t)
-
-# disksup tries to monitor the local disks
 fs_getattr_xattr_fs(couchdb_t)
-fs_dontaudit_getattr_all_fs(couchdb_t)
-files_dontaudit_getattr_lost_found_dirs(couchdb_t)
-files_dontaudit_list_var(couchdb_t)
-files_dontaudit_search_all_mountpoints(couchdb_t)
 
 auth_use_nsswitch(couchdb_t)
 
-miscfiles_read_localization(couchdb_t)
-
-########################################
-#
-# couchdb_js policy
-#
-
-# this is a complete policy. It processes the javascript
-# ouside the main process, passing data via FIFO.
-allow couchdb_js_t self:process { execmem getsched setsched };
-
-files_read_usr_files(couchdb_js_t)
-miscfiles_read_localization(couchdb_js_t)
Index: serefpolicy-contrib-20140730/courier.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/courier.fc
+++ serefpolicy-contrib-20140730/courier.fc
@@ -11,17 +11,18 @@
 /usr/sbin/imaplogin	--	gen_context(system_u:object_r:courier_pop_exec_t,s0)
 
 /usr/lib/courier/authlib/.*	--	gen_context(system_u:object_r:courier_authdaemon_exec_t,s0)
-/usr/lib/courier/courier-authlib/.*	--	gen_context(system_u:object_r:courier_authdaemon_exec_t,s0)
 /usr/lib/courier/courier/.*	--	gen_context(system_u:object_r:courier_exec_t,s0)
-/usr/lib/courier/courier/courierpop.*	--	gen_context(system_u:object_r:courier_pop_exec_t,s0)
-/usr/lib/courier/courier/imaplogin	--	gen_context(system_u:object_r:courier_pop_exec_t,s0)
+/usr/lib/courier/courier/courierpop.* --	gen_context(system_u:object_r:courier_pop_exec_t,s0)
+/usr/lib/courier/courier/imaplogin --	gen_context(system_u:object_r:courier_pop_exec_t,s0)
 /usr/lib/courier/courier/pcpd	--	gen_context(system_u:object_r:courier_pcp_exec_t,s0)
-/usr/lib/courier/imapd	--	gen_context(system_u:object_r:courier_pop_exec_t,s0)
-/usr/lib/courier/pop3d	--	gen_context(system_u:object_r:courier_pop_exec_t,s0)
-/usr/lib/courier/rootcerts(/.*)?	gen_context(system_u:object_r:courier_etc_t,s0)
-/usr/lib/courier/sqwebmail/cleancache\.pl	--	gen_context(system_u:object_r:sqwebmail_cron_exec_t,s0)
-/usr/lib/courier-imap/couriertcpd	--	gen_context(system_u:object_r:courier_tcpd_exec_t,s0)
+/usr/lib/courier/imapd		--	gen_context(system_u:object_r:courier_pop_exec_t,s0)
+/usr/lib/courier/pop3d		--	gen_context(system_u:object_r:courier_pop_exec_t,s0)
+/usr/lib/courier/rootcerts(/.*)?		gen_context(system_u:object_r:courier_etc_t,s0)
+/usr/lib/courier/sqwebmail/cleancache\.pl -- gen_context(system_u:object_r:sqwebmail_cron_exec_t,s0)
 
+ifdef(`distro_gentoo',`
+/usr/lib/courier-imap/couriertcpd	--	gen_context(system_u:object_r:courier_tcpd_exec_t,s0)
+')
 
 /var/lib/courier(/.*)?	gen_context(system_u:object_r:courier_var_lib_t,s0)
 /var/lib/courier-imap(/.*)?	gen_context(system_u:object_r:courier_var_lib_t,s0)
